/*
* Copyright (C) 2011-2015 MediaTek Inc.
*
* This program is free software: you can redistribute it and/or modify it under the terms of the
* GNU General Public License version 2 as published by the Free Software Foundation.
*
* This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
* without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
* See the GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License along with this program.
* If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef _CUST_BATTERY_METER_TABLE_H
#define _CUST_BATTERY_METER_TABLE_H

#include <mach/mt_typedefs.h>
#include <mach/battery_meter.h>

/* ============================================================ */
/* define */
/* ============================================================ */
#define BAT_NTC_10 1
#define BAT_NTC_47 0

#if (BAT_NTC_10 == 1)
#define RBAT_PULL_UP_R             16900
#define RBAT_PULL_DOWN_R		   27000
#endif

#if (BAT_NTC_47 == 1)
#define RBAT_PULL_UP_R             61900
#define RBAT_PULL_DOWN_R		  100000
#endif
#define RBAT_PULL_UP_VOLT          1800



/* ============================================================ */
/* ENUM */
/* ============================================================ */

/* ============================================================ */
/* structure */
/* ============================================================ */

/* ============================================================ */
/* typedef */
/* ============================================================ */

/* ============================================================ */
/* External Variables */
/* ============================================================ */

/* ============================================================ */
/* External function */
/* ============================================================ */

/* ============================================================ */
/* <DOD, Battery_Voltage> Table */
/* ============================================================ */
#if (BAT_NTC_10 == 1)
BATT_TEMPERATURE Batt_Temperature_Table[] = {
	{-20, 68237},
	{-15, 53650},
	{-10, 42506},
	{-5, 33892},
	{0, 27219},
	{5, 22021},
	{10, 17926},
	{15, 14674},
	{20, 12081},
	{25, 10000},
	{30, 8315},
	{35, 6948},
	{40, 5834},
	{45, 4917},
	{50, 4161},
	{55, 3535},
	{60, 3014}
};
#endif

#if (BAT_NTC_47 == 1)
BATT_TEMPERATURE Batt_Temperature_Table[] = {
	{-20, 483954},
	{-15, 360850},
	{-10, 271697},
	{-5, 206463},
	{0, 158214},
	{5, 122259},
	{10, 95227},
	{15, 74730},
	{20, 59065},
	{25, 47000},
	{30, 37643},
	{35, 30334},
	{40, 24591},
	{45, 20048},
	{50, 16433},
	{55, 13539},
	{60, 11210}
};
#endif

/* T0 -10C */
BATTERY_PROFILE_STRUC battery_profile_t0[] = {
	{0, 4145},
	{2, 4133},
	{4, 4122},
	{6, 4111},
	{9, 4100},
	{11, 4090},
	{13, 4081},
	{15, 4071},
	{17, 4062},
	{19, 4053},
	{21, 4045},
	{23, 4038},
	{26, 4030},
	{28, 4023},
	{30, 4015},
	{32, 4006},
	{34, 3997},
	{36, 3988},
	{38, 3970},
	{40, 3934},
	{43, 3885},
	{45, 3863},
	{47, 3852},
	{49, 3844},
	{51, 3837},
	{53, 3830},
	{55, 3823},
	{57, 3819},
	{59, 3812},
	{62, 3804},
	{64, 3798},
	{66, 3789},
	{68, 3781},
	{70, 3772},
	{72, 3760},
	{74, 3751},
	{76, 3739},
	{78, 3726},
	{81, 3717},
	{83, 3710},
	{85, 3703},
	{87, 3697},
	{89, 3689},
	{91, 3677},
	{93, 3661},
	{95, 3645},
	{96, 3632},
	{96, 3616},
	{97, 3606},
	{97, 3598},
	{98, 3587},
	{98, 3582},
	{98, 3575},
	{98, 3569},
	{98, 3563},
	{99, 3560},
	{99, 3554},
	{99, 3553},
	{99, 3549},
	{99, 3548},
	{99, 3544},
	{99, 3541},
	{99, 3540},
	{99, 3536},
	{99, 3533},
	{99, 3530},
	{99, 3531},
	{99, 3529},
	{99, 3527},
	{99, 3526},
	{99, 3524},
	{99, 3523},
	{99, 3521},
	{100, 3519},
	{100, 3516},
	{100, 3515},
	{100, 3511},
	{100, 3511},
	{100, 3507},
	{100, 3506},
	{100, 3504},
	{100, 3503},
	{100, 3501},
	{100, 3498},
	{100, 3494},
	{100, 3492},
	{100, 3488},
	{100, 3487},
};


/* T1 0C */
BATTERY_PROFILE_STRUC battery_profile_t1[] = {
	{0, 4178},
	{2, 4167},
	{3, 4155},
	{5, 4142},
	{7, 4132},
	{9, 4120},
	{10, 4111},
	{12, 4100},
	{14, 4089},
	{16, 4076},
	{17, 4044},
	{19, 4001},
	{21, 3974},
	{23, 3959},
	{24, 3948},
	{26, 3935},
	{28, 3924},
	{30, 3912},
	{31, 3902},
	{33, 3893},
	{35, 3882},
	{37, 3875},
	{38, 3868},
	{40, 3862},
	{42, 3857},
	{44, 3851},
	{46, 3844},
	{47, 3839},
	{49, 3834},
	{51, 3829},
	{53, 3825},
	{54, 3819},
	{56, 3815},
	{58, 3811},
	{60, 3806},
	{61, 3800},
	{63, 3795},
	{65, 3790},
	{67, 3785},
	{68, 3778},
	{70, 3772},
	{72, 3763},
	{73, 3757},
	{75, 3748},
	{77, 3738},
	{79, 3729},
	{80, 3719},
	{82, 3711},
	{84, 3704},
	{86, 3701},
	{87, 3697},
	{89, 3693},
	{91, 3688},
	{93, 3676},
	{94, 3654},
	{96, 3613},
	{98, 3547},
	{100, 3449},
	{100, 3371},
	{100, 3342},
	{100, 3328},
	{100, 3323},
	{100, 3318},
	{100, 3311},
	{100, 3309},
	{100, 3306},
	{100, 3302},
	{100, 3300},
	{100, 3295},
	{100, 3293},
	{100, 3286},
	{100, 3280},
	{100, 3277},
	{100, 3271},
	{100, 3267},
	{100, 3263},
	{100, 3258},
	{100, 3251},
	{100, 3245},
	{100, 3239},
	{100, 3233},
	{100, 3226},
	{100, 3218},
	{100, 3210},
	{100, 3201},
	{100, 3193},
	{100, 3182},
	{100, 3170},
};

/* T2 25C */
BATTERY_PROFILE_STRUC battery_profile_t2[] = {
	{0, 4179},
	{1, 4161},
	{3, 4149},
	{4, 4135},
	{5, 4122},
	{6, 4111},
	{8, 4100},
	{9, 4089},
	{10, 4077},
	{12, 4066},
	{13, 4057},
	{14, 4045},
	{16, 4036},
	{17, 4026},
	{18, 4017},
	{19, 4007},
	{21, 3998},
	{22, 3989},
	{23, 3981},
	{25, 3972},
	{26, 3965},
	{27, 3957},
	{29, 3948},
	{30, 3941},
	{31, 3933},
	{33, 3926},
	{34, 3919},
	{35, 3911},
	{36, 3903},
	{38, 3895},
	{39, 3884},
	{40, 3874},
	{42, 3862},
	{43, 3853},
	{44, 3847},
	{46, 3839},
	{47, 3834},
	{48, 3830},
	{49, 3824},
	{51, 3818},
	{52, 3815},
	{53, 3810},
	{54, 3807},
	{56, 3804},
	{57, 3801},
	{58, 3798},
	{60, 3794},
	{61, 3792},
	{62, 3788},
	{64, 3787},
	{65, 3782},
	{66, 3781},
	{68, 3779},
	{69, 3775},
	{70, 3771},
	{71, 3769},
	{73, 3765},
	{74, 3759},
	{75, 3754},
	{77, 3749},
	{78, 3746},
	{79, 3740},
	{81, 3734},
	{82, 3726},
	{83, 3717},
	{85, 3710},
	{86, 3699},
	{87, 3690},
	{88, 3685},
	{90, 3682},
	{91, 3681},
	{92, 3678},
	{94, 3672},
	{95, 3661},
	{96, 3626},
	{97, 3573},
	{99, 3502},
	{100, 3403},
	{100, 3227},
	{100, 3150},
	{100, 3108},
	{100, 3077},
	{100, 3059},
	{100, 3040},
	{100, 3027},
	{100, 3012},
	{100, 2995},
	{100, 2978},
};

/* T3 50C */
BATTERY_PROFILE_STRUC battery_profile_t3[] = {
	{0, 4191},
	{1, 4178},
	{2, 4164},
	{4, 4151},
	{5, 4139},
	{6, 4127},
	{8, 4115},
	{9, 4103},
	{10, 4091},
	{11, 4080},
	{13, 4070},
	{14, 4060},
	{15, 4049},
	{17, 4039},
	{18, 4029},
	{19, 4018},
	{20, 4009},
	{22, 4001},
	{23, 3992},
	{24, 3981},
	{26, 3974},
	{27, 3965},
	{28, 3957},
	{29, 3949},
	{31, 3942},
	{32, 3935},
	{33, 3927},
	{34, 3919},
	{36, 3913},
	{37, 3905},
	{38, 3900},
	{40, 3890},
	{41, 3879},
	{42, 3868},
	{43, 3857},
	{45, 3850},
	{46, 3843},
	{47, 3836},
	{49, 3830},
	{50, 3825},
	{51, 3821},
	{52, 3817},
	{53, 3813},
	{55, 3807},
	{56, 3803},
	{57, 3801},
	{59, 3797},
	{60, 3795},
	{61, 3791},
	{63, 3787},
	{64, 3785},
	{65, 3783},
	{66, 3778},
	{68, 3776},
	{69, 3771},
	{70, 3764},
	{72, 3756},
	{73, 3751},
	{74, 3746},
	{75, 3741},
	{77, 3737},
	{78, 3730},
	{79, 3725},
	{80, 3720},
	{82, 3715},
	{83, 3707},
	{84, 3699},
	{85, 3689},
	{87, 3678},
	{88, 3672},
	{89, 3669},
	{91, 3668},
	{92, 3665},
	{93, 3662},
	{94, 3653},
	{96, 3632},
	{97, 3588},
	{98, 3533},
	{100, 3453},
	{100, 3327},
	{100, 3073},
	{100, 2976},
	{100, 2939},
	{100, 2914},
	{100, 2907},
	{100, 2907},
	{100, 2892},
	{100, 2873},
};


/* battery profile for actual temperature. The size should be the same as T1, T2 and T3 */
BATTERY_PROFILE_STRUC battery_profile_temperature[] = {
	{0, 0},
	{0, 0},
	{0, 0},
	{0, 0},
	{0, 0},
	{0, 0},
	{0, 0},
	{0, 0},
	{0, 0},
	{0, 0},
	{0, 0},
	{0, 0},
	{0, 0},
	{0, 0},
	{0, 0},
	{0, 0},
	{0, 0},
	{0, 0},
	{0, 0},
	{0, 0},
	{0, 0},
	{0, 0},
	{0, 0},
	{0, 0},
	{0, 0},
	{0, 0},
	{0, 0},
	{0, 0},
	{0, 0},
	{0, 0},
	{0, 0},
	{0, 0},
	{0, 0},
	{0, 0},
	{0, 0},
	{0, 0},
	{0, 0},
	{0, 0},
	{0, 0},
	{0, 0},
	{0, 0},
	{0, 0},
	{0, 0},
	{0, 0},
	{0, 0},
	{0, 0},
	{0, 0},
	{0, 0},
	{0, 0},
	{0, 0},
	{0, 0},
	{0, 0},
	{0, 0},
	{0, 0},
	{0, 0},
	{0, 0},
	{0, 0},
	{0, 0},
	{0, 0},
	{0, 0},
	{0, 0},
	{0, 0},
	{0, 0},
	{0, 0},
	{0, 0},
	{0, 0},
	{0, 0},
	{0, 0},
	{0, 0},
	{0, 0},
	{0, 0},
	{0, 0},
	{0, 0},
	{0, 0},
	{0, 0},
	{0, 0},
	{0, 0},
	{0, 0},
	{0, 0},
	{0, 0},
	{0, 0},
	{0, 0},
	{0, 0},
	{0, 0},
	{0, 0},
	{0, 0},
	{0, 0},
	{0, 0}
};

/* ============================================================ */
/* <Rbat, Battery_Voltage> Table */
/* ============================================================ */
/* T0 -10C */
R_PROFILE_STRUC r_profile_t0[] = {
	{1043, 4145},
	{1043, 4133},
	{1033, 4122},
	{1033, 4111},
	{1038, 4100},
	{1045, 4090},
	{1068, 4081},
	{1083, 4071},
	{1073, 4062},
	{1065, 4053},
	{1083, 4045},
	{1115, 4038},
	{1095, 4030},
	{1103, 4023},
	{1110, 4015},
	{1138, 4006},
	{1180, 3997},
	{1210, 3988},
	{1313, 3970},
	{1623, 3934},
	{1878, 3885},
	{2043, 3863},
	{2043, 3852},
	{2033, 3844},
	{2023, 3837},
	{2048, 3830},
	{2068, 3823},
	{2095, 3819},
	{2090, 3812},
	{2098, 3804},
	{2098, 3798},
	{2105, 3789},
	{2105, 3781},
	{2113, 3772},
	{2090, 3760},
	{2083, 3751},
	{2118, 3739},
	{2098, 3726},
	{2115, 3717},
	{2090, 3710},
	{2098, 3703},
	{2108, 3697},
	{2123, 3689},
	{2135, 3677},
	{2155, 3661},
	{2115, 3645},
	{2080, 3632},
	{2055, 3616},
	{2020, 3606},
	{2005, 3598},
	{1970, 3587},
	{1963, 3582},
	{1945, 3575},
	{1938, 3569},
	{1920, 3563},
	{1928, 3560},
	{1905, 3554},
	{1900, 3553},
	{1878, 3549},
	{1880, 3548},
	{1890, 3544},
	{1883, 3541},
	{1870, 3540},
	{1868, 3536},
	{1858, 3533},
	{1855, 3530},
	{1835, 3531},
	{1838, 3529},
	{1850, 3527},
	{1840, 3526},
	{1828, 3524},
	{1855, 3523},
	{1868, 3521},
	{1803, 3519},
	{1820, 3516},
	{1813, 3515},
	{1880, 3511},
	{1833, 3511},
	{1835, 3507},
	{1833, 3506},
	{1808, 3504},
	{1828, 3503},
	{1778, 3501},
	{1853, 3498},
	{1875, 3494},
	{1853, 3492},
	{1870, 3488},
	{1843, 3487},
};


/* T1 0C */
R_PROFILE_STRUC r_profile_t1[] = {
	{453, 4178},
	{453, 4167},
	{460, 4155},
	{463, 4142},
	{475, 4132},
	{473, 4120},
	{493, 4111},
	{485, 4100},
	{505, 4089},
	{518, 4076},
	{615, 4044},
	{880, 4001},
	{1130, 3974},
	{1150, 3959},
	{1185, 3948},
	{1168, 3935},
	{1185, 3924},
	{1165, 3912},
	{1180, 3902},
	{1180, 3893},
	{1165, 3882},
	{1188, 3875},
	{1173, 3868},
	{1185, 3862},
	{1188, 3857},
	{1203, 3851},
	{1188, 3844},
	{1205, 3839},
	{1198, 3834},
	{1198, 3829},
	{1215, 3825},
	{1198, 3819},
	{1225, 3815},
	{1210, 3811},
	{1225, 3806},
	{1210, 3800},
	{1238, 3795},
	{1223, 3790},
	{1245, 3785},
	{1228, 3778},
	{1223, 3772},
	{1240, 3763},
	{1238, 3757},
	{1225, 3748},
	{1238, 3738},
	{1233, 3729},
	{1228, 3719},
	{1250, 3711},
	{1238, 3704},
	{1268, 3701},
	{1268, 3697},
	{1270, 3693},
	{1305, 3688},
	{1295, 3676},
	{1305, 3654},
	{1330, 3613},
	{1335, 3547},
	{1400, 3449},
	{1433, 3371},
	{1365, 3342},
	{1333, 3328},
	{1330, 3323},
	{1300, 3318},
	{1300, 3311},
	{1278, 3309},
	{1275, 3306},
	{1280, 3302},
	{1255, 3300},
	{1263, 3295},
	{1250, 3293},
	{1263, 3286},
	{1248, 3280},
	{1248, 3277},
	{1225, 3271},
	{1238, 3267},
	{1160, 3263},
	{1265, 3258},
	{1258, 3251},
	{1260, 3245},
	{1248, 3239},
	{1188, 3233},
	{1180, 3226},
	{1290, 3218},
	{1263, 3210},
	{1293, 3201},
	{1330, 3193},
	{1213, 3182},
	{1220, 3170},
};


/* T2 25C */
R_PROFILE_STRUC r_profile_t2[] = {
	{343, 4179},
	{343, 4161},
	{353, 4149},
	{355, 4135},
	{360, 4122},
	{363, 4111},
	{378, 4100},
	{383, 4089},
	{383, 4077},
	{380, 4066},
	{390, 4057},
	{388, 4045},
	{393, 4036},
	{393, 4026},
	{393, 4017},
	{393, 4007},
	{398, 3998},
	{395, 3989},
	{393, 3981},
	{398, 3972},
	{408, 3965},
	{405, 3957},
	{403, 3948},
	{408, 3941},
	{408, 3933},
	{408, 3926},
	{415, 3919},
	{413, 3911},
	{413, 3903},
	{413, 3895},
	{405, 3884},
	{400, 3874},
	{390, 3862},
	{385, 3853},
	{388, 3847},
	{380, 3839},
	{388, 3834},
	{390, 3830},
	{383, 3824},
	{383, 3818},
	{385, 3815},
	{385, 3810},
	{390, 3807},
	{398, 3804},
	{400, 3801},
	{403, 3798},
	{400, 3794},
	{405, 3792},
	{403, 3788},
	{410, 3787},
	{403, 3782},
	{403, 3781},
	{405, 3779},
	{400, 3775},
	{393, 3771},
	{398, 3769},
	{395, 3765},
	{393, 3759},
	{388, 3754},
	{388, 3749},
	{393, 3746},
	{388, 3740},
	{388, 3734},
	{385, 3726},
	{388, 3717},
	{388, 3710},
	{390, 3699},
	{385, 3690},
	{388, 3685},
	{388, 3682},
	{395, 3681},
	{405, 3678},
	{415, 3672},
	{433, 3661},
	{425, 3626},
	{448, 3573},
	{483, 3502},
	{545, 3403},
	{845, 3227},
	{928, 3150},
	{770, 3108},
	{723, 3077},
	{678, 3059},
	{675, 3040},
	{653, 3027},
	{678, 3012},
	{705, 2995},
	{735, 2978},
};


/* T3 50C */
R_PROFILE_STRUC r_profile_t3[] = {
	{153, 4191},
	{153, 4178},
	{158, 4164},
	{158, 4151},
	{155, 4139},
	{158, 4127},
	{160, 4115},
	{158, 4103},
	{158, 4091},
	{158, 4080},
	{160, 4070},
	{165, 4060},
	{163, 4049},
	{165, 4039},
	{163, 4029},
	{163, 4018},
	{168, 4009},
	{170, 4001},
	{170, 3992},
	{165, 3981},
	{170, 3974},
	{170, 3965},
	{170, 3957},
	{173, 3949},
	{178, 3942},
	{180, 3935},
	{178, 3927},
	{178, 3919},
	{183, 3913},
	{178, 3905},
	{185, 3900},
	{178, 3890},
	{173, 3879},
	{165, 3868},
	{160, 3857},
	{158, 3850},
	{155, 3843},
	{155, 3836},
	{155, 3830},
	{153, 3825},
	{155, 3821},
	{158, 3817},
	{155, 3813},
	{158, 3807},
	{155, 3803},
	{160, 3801},
	{160, 3797},
	{163, 3795},
	{163, 3791},
	{160, 3787},
	{165, 3785},
	{165, 3783},
	{165, 3778},
	{165, 3776},
	{160, 3771},
	{155, 3764},
	{155, 3756},
	{158, 3751},
	{155, 3746},
	{158, 3741},
	{158, 3737},
	{155, 3730},
	{153, 3725},
	{155, 3720},
	{158, 3715},
	{155, 3707},
	{155, 3699},
	{155, 3689},
	{150, 3678},
	{150, 3672},
	{153, 3669},
	{155, 3668},
	{163, 3665},
	{173, 3662},
	{175, 3653},
	{180, 3632},
	{178, 3588},
	{193, 3533},
	{203, 3453},
	{225, 3327},
	{715, 3073},
	{500, 2976},
	{418, 2939},
	{350, 2914},
	{298, 2907},
	{283, 2907},
	{318, 2892},
	{293, 2873},
};

/* r-table profile for actual temperature. The size should be the same as T1, T2 and T3 */
R_PROFILE_STRUC r_profile_temperature[] = {
	{0, 0},
	{0, 0},
	{0, 0},
	{0, 0},
	{0, 0},
	{0, 0},
	{0, 0},
	{0, 0},
	{0, 0},
	{0, 0},
	{0, 0},
	{0, 0},
	{0, 0},
	{0, 0},
	{0, 0},
	{0, 0},
	{0, 0},
	{0, 0},
	{0, 0},
	{0, 0},
	{0, 0},
	{0, 0},
	{0, 0},
	{0, 0},
	{0, 0},
	{0, 0},
	{0, 0},
	{0, 0},
	{0, 0},
	{0, 0},
	{0, 0},
	{0, 0},
	{0, 0},
	{0, 0},
	{0, 0},
	{0, 0},
	{0, 0},
	{0, 0},
	{0, 0},
	{0, 0},
	{0, 0},
	{0, 0},
	{0, 0},
	{0, 0},
	{0, 0},
	{0, 0},
	{0, 0},
	{0, 0},
	{0, 0},
	{0, 0},
	{0, 0},
	{0, 0},
	{0, 0},
	{0, 0},
	{0, 0},
	{0, 0},
	{0, 0},
	{0, 0},
	{0, 0},
	{0, 0},
	{0, 0},
	{0, 0},
	{0, 0},
	{0, 0},
	{0, 0},
	{0, 0},
	{0, 0},
	{0, 0},
	{0, 0},
	{0, 0},
	{0, 0},
	{0, 0},
	{0, 0},
	{0, 0},
	{0, 0},
	{0, 0},
	{0, 0},
	{0, 0},
	{0, 0},
	{0, 0},
	{0, 0},
	{0, 0},
	{0, 0},
	{0, 0},
	{0, 0},
	{0, 0},
	{0, 0},
	{0, 0}
};

/* ============================================================ */
/* function prototype */
/* ============================================================ */
int fgauge_get_saddles(void);
BATTERY_PROFILE_STRUC_P fgauge_get_profile(kal_uint32 temperature);

int fgauge_get_saddles_r_table(void);
R_PROFILE_STRUC_P fgauge_get_profile_r_table(kal_uint32 temperature);

#endif				/* #ifndef _CUST_BATTERY_METER_TABLE_H */
